"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addFastServe = void 0;
const yargs_1 = require("yargs");
const path = __importStar(require("path"));
const os_1 = require("os");
const crypto_1 = require("crypto");
const node_fetch_1 = __importDefault(require("node-fetch"));
const del_1 = __importDefault(require("del"));
const tasks_1 = require("./tasks");
function addFastServe(build) {
    const useCustomServe = yargs_1.argv['custom-serve'];
    const isClean = yargs_1.argv._.indexOf('clean') !== -1;
    if (isClean) {
        del_1.default.sync(['src/**/*.module.scss.d.ts', 'release'], { cwd: path.resolve(process.cwd()) });
    }
    if (!useCustomServe)
        return;
    trackAnalytics();
    build.addSuppression(/Error processing webpack stats: TypeError/gi);
    build.addSuppression(/Webpack error: RangeError: Invalid string length/gi);
    build.tslintCmd.enabled = false;
    tasks_1.addSaveConfigTask(build);
}
exports.addFastServe = addFastServe;
function trackAnalytics() {
    try {
        let username = 'default';
        try {
            username = os_1.userInfo().username;
        }
        catch (e) {
        }
        const hostNameHash = crypto_1.createHash('md5').update(os_1.hostname() + '@' + username).digest('hex');
        node_fetch_1.default('https://fast-serve-track.azurewebsites.net/api/track', {
            method: 'post',
            headers: {
                'Content-Type': 'application/json',
                'x-functions-key': 'TX0jA2PGYZQFJgeJeqSJbRcYwV7tx72vOD2LkICWxLe1O0f6KxxLaQ=='
            },
            body: JSON.stringify({
                hostNameHash
            })
        });
    }
    catch (err) {
    }
}
//# sourceMappingURL=gulp.js.map